part of disposable;

/// Marks a class which contains references that should be cleaned up after their use
abstract class IDisposable {
  void dispose([dynamic value]); // Triggers cleanup on the target disposable
}

abstract class IFutureDisposable implements IDisposable {
  void disposeError(dynamic error); // Triggers cleanup on the target disposable and passes the error to the Future listener
  Future get disposed;
}